﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using System.Drawing;
using System.Runtime;
using System.Xml;
using ScriptPortal.Vegas;

namespace Test_Script
{
    public class Class1
    {
        public Vegas myVegas;
        private string[] filenames;
        public static FileStream OutStream;
        public static StreamWriter OutWriter;

        public void Main(Vegas vegas)
        {
            myVegas = vegas;

            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "VEGAS Projects (*.veg)|*.veg|All Files (*.*)|*.*";
            ofd.Multiselect = true;
            ofd.Title = "Select the VEGAS Projects to process";
            DialogResult dr = ofd.ShowDialog();
            if (dr == System.Windows.Forms.DialogResult.OK)
            {
                filenames = ofd.FileNames;

                foreach(string file in filenames)
                {
                    myVegas.NewProject(false, false);
                    myVegas.OpenProject(file);
                    string OutputFile = Path.GetDirectoryName(file) + Path.DirectorySeparatorChar + Path.GetFileNameWithoutExtension(file) + ".txt";

                    if (File.Exists(OutputFile))
                    {
                        File.Delete(OutputFile);
                    }

                    OutStream = new FileStream(OutputFile, FileMode.OpenOrCreate);
                    OutWriter = new StreamWriter(OutStream);

                    foreach (Track myTrack in myVegas.Project.Tracks)
                    {
                        string trackType = "Video   ";
                        if (myTrack.IsAudio())
                        {
                            trackType = "Audio   ";
                        }
                        foreach (TrackEvent evnt in myTrack.Events)
                        {
                            if (!evnt.ActiveTake.Media.IsGenerated())
                            {
                                string outLine = (myTrack.Index + 1) + "   " + trackType;
                                outLine = outLine + evnt.Start.ToString() + "   " + evnt.End.ToString() + "   ";
                                outLine = outLine + evnt.ActiveTake.Offset.ToString() + "   " + evnt.Length.ToString() + "   ";
                                outLine = outLine + evnt.ActiveTake.MediaPath;

                                OutWriter.WriteLine(outLine);
                            }
                        }

                    }

                    OutWriter.Close();
                    OutStream.Close();
                }
                myVegas.NewProject(false, false);
            }
        }
    }
}

public class EntryPoint
{
    public void FromVegas(Vegas vegas)
    //public void FromVegas(Vegas vegas, String scriptFile, XmlDocument scriptSettings, ScriptArgs args)
    {
        Test_Script.Class1 test = new Test_Script.Class1();
        test.Main(vegas);
    }
}